Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
colombus

[Yêu Cầu] Lisp Đổi Dấu Scale X, Scale Y Của Block

Các bài được khuyến nghị

colombus    0
Xin các bạn giúp cho cái lisp này để thuận tiện hơn trong công việc.

 

Tôi muốn đổi dấu cho tỷ lệ X và Y của block (từ + sang - hoặc từ - sang +) để nó có thể lật qua , lật lại quanh điểm insert theo các hướng X và Y

 

Cái này nó cũng giống như FLIP trong dynamic block. Nhưng ở đây tôi phải chọn nhiều block cùng lúc và thực hiện lệnh thì mới nhanh được , chứ click vào từng block ròi flip từng cái thì lâu quá.

 

Chẳng hạn tôi muốn gọi lệnh bx để đổi dấu cho scale X, lệnh by để đổi dấu cho scale Y.

 

gọi lệnh trước rồi chọn đối tượng hay chọn đối tượng trước rồi gọi lệnh đều được.

 

tôi cũng muốn học lisp rồi tự viết cho tiện. Khổ nỗi thời gian ngặt nghèo quá nên đành nhờ trợ giúp. Hy vọng lisp này cũng có ích với nhiều người khác và như vậy thì sự đòi hỏi của tôi cũng không đến nỗi "ích kỷ"

XIN CẢM ƠN.

  • Vote giảm 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
quocmanh04tt    385

 

Xin các bạn giúp cho cái lisp này để thuận tiện hơn trong công việc.
 
Tôi muốn đổi dấu cho tỷ lệ X và Y của block (từ + sang - hoặc từ - sang +) để nó có thể lật qua , lật lại quanh điểm insert theo các hướng X và Y
 
Cái này nó cũng giống như FLIP trong dynamic block. Nhưng ở đây tôi phải chọn nhiều block cùng lúc và thực hiện lệnh thì mới nhanh được , chứ click vào từng block ròi flip từng cái thì lâu quá.
 
Chẳng hạn tôi muốn gọi lệnh bx để đổi dấu cho scale X, lệnh by để đổi dấu cho scale Y.
 
gọi lệnh trước rồi chọn đối tượng hay chọn đối tượng trước rồi gọi lệnh đều được.
 
tôi cũng muốn học lisp rồi tự viết cho tiện. Khổ nỗi thời gian ngặt nghèo quá nên đành nhờ trợ giúp. Hy vọng lisp này cũng có ích với nhiều người khác và như vậy thì sự đòi hỏi của tôi cũng không đến nỗi "ích kỷ"
XIN CẢM ƠN.

 

Bạn thử cái này xem:

(defun getscale_blk  (/ ent i ss)
 (if (setq ss (ssget '((0 . "INSERT"))))
  (repeat (setq i (sslength ss))
   (setq ent (ssname ss (setq i (1- i)))
         blk (vlax-ename->vla-object ent)
         scx (* (vlax-get blk 'XScaleFactor) -1)
         scy (* (vlax-get blk 'YScaleFactor) -1)))))
(defun c:bx (/ blk scx scy)
 (and (getscale_blk)
      (vlax-put blk 'XScaleFactor scx))(princ))
(defun c:by (/ blk scx scy)
 (and (getscale_blk)
      (vlax-put blk 'YScaleFactor scy))(princ))
(vl-load-com)
  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tot77    501

quocmanh04tt xem lại nếu chọn nhiều block thì chỉ 1 cái cuối cùng đổi thôi, mấy cái kia không đổi.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
colombus    0

quocmanh04tt xem lại nếu chọn nhiều block thì chỉ 1 cái cuối cùng đổi thôi, mấy cái kia không đổi.

Ừ NHỈ ĐÚNG THẾ THẬT. kiểm tra vội vàng nên không thấy. 

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
quocmanh04tt    385

Xin lỗi các bác...! Sai cơ bản :D

Em sửa lại đây:

(vl-load-com)
(defun getscale_blk  (x / blk ent i scx scy ss)
 (if (setq ss (ssget '((0 . "INSERT"))))
  (repeat (setq i (sslength ss))
   (setq ent (ssname ss (setq i (1- i)))
         blk (vlax-ename->vla-object ent)
         scx (* (vlax-get blk 'XScaleFactor) -1)
         scy (* (vlax-get blk 'YScaleFactor) -1))
   (if (eq x t)
    (vlax-put blk 'XScaleFactor scx)
    (vlax-put blk 'YScaleFactor scy))))(princ))
(defun c:bx () (getscale_blk t))
(defun c:by () (getscale_blk nil))
  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×